E_M4WARNING

/*
 * 	ECO: Efficient Collective Operations
 * 	Beta release 0.1b
 * 	Bruce Lowekamp and Adam Beguelin	
 * 	School of Computer Science
 * 	Carnegie Mellon University
 * 	Pittsburgh, PA 15213
 * 
 * 	(C) 1996 All Rights Reserved
 * 
 * NOTICE:
 * 
 *  Permission to use, copy, modify, and distribute this software and
 *  its documentation for any purpose and without fee is hereby granted
 *  provided that the above copyright notice appear in all copies and
 *  that both the copyright notice and this permission notice appear in
 *  supporting documentation.
 * 
 *  Neither Carnegie Mellon University nor the Authors make any
 *  representations about the suitability of this software for any
 *  purpose.  This software is provided ``as is'' without express or
 *  implied warranty.
 * 
 *  This research is sponsored in part by the Department of Defense
 *  Advanced Research Projects Agency and the National Science
 *  Foundation.
 */


/*
 * spawn_mpp.h
 * define mpp info structure needed for data on mpp's and include prototype
 * for alb_spawn since we have this file anyway
 */

#ifndef _SPAWN_MPP_H
#define _SPAWN_MPP_H


ifdef(`E_CPLUSPLUS',
`const int MaxHostName=65;
class mpp_info {
public:
  char hostname[MaxHostName];
  int processors;
  int n_assigned;
};',
`#define MaxHostName 65
typedef struct {
  char hostname[MaxHostName];
  int processors;
  int n_assigned;
} mpp_info;
')

#if defined(__STDC__) || defined(__cplusplus)
int alb_spawn(char *comp, char **args, int ntids, int *tids,
	      mpp_info *mpp_hostinfo, int mpp_host_count,
	      int pvm_flags);
#endif
#endif
